Program Matrix2;

Type
  Matrix = Array [1..10, 1..10] of Real;

Var
  n, m, i, j, l: Byte;
  a, b, c, c1, c2, c3, c4: Matrix;

Procedure Inp_Matrix(var m1:Matrix; var m2: matrix);
Begin
  for i := 1 to n do
    for j := 1 to m do
      ReadLn(m1[i,j], m2[i,j]);
End;

Procedure Out_Matrix(m1: Matrix);
Begin
  for i:=1 to n do
    for j := 1 to m do
      WriteLn(m1[i,j]);
End;

Procedure Mul_Matrix(m1, m2: Matrix; var m3: Matrix);
Begin
  for i := 1 to n do
    for j := 1 to m do
    begin
      m3[i,j] := 0;
      for l := 1 to n do
        m3[i,j] := m3[i,j] + m1[i,j] * m2[i,j];
    end;
End;

Procedure Sum_Matrix(m1, m2: Matrix; var m3: Matrix);
Begin
  for i := 1 to n do
    for j := 1 to m do
      m3[i,j] := m1[i,j] + m2[i,j];
End;

Procedure Min_Matrix(m1, m2: Matrix; var m3: Matrix);
Begin
  for i := 1 to n do
    for j := 1 to m do
      m3[i,j] := m1[i,j] - m2[i,j];
End;

Procedure Mul2Sc_Matrix(m1: Matrix; r: Real; var m2: Matrix);
Begin
  for i := 1 to n do
    for j := 1 to m do
      m2[i,j] := m1[i,j] * r;
End;

Begin
  ReadLn(n, m);
  Inp_Matrix(a, b);
  Mul_Matrix(a, a, c);
  Sum_Matrix(c, b, c1);
  Min_Matrix(a, b, c2);
  Mul_Matrix(c2, c1, c3);
  Mul2Sc_Matrix(c3, 2, c4);
  Out_Matrix(c4);
End.