Type
  Location = Record
    ZIP: String[6];
    City: String;
    Street: String;
    House: Word;
    Korpus: Byte;
    Kvartira: Word;
  End;
  Date = Record
    Day: Byte;
    Month: Byte;
    Year: Word;
  End;
  Note = Record
    Name: String;
    BirthDate: Date;
    Phone: String;
    Adr: Location;
  End;
Var
  TempByte: Byte;
  TempInteger, Error: Integer;
  TempStr: String;
  NoteBook: Array [1..10] of Note;
  Notes, N: Word;
  CurrentDate: Date;
Begin
  Write('쪮 ᥩ 㤥 ? ');
  ReadLn(Notes);
  For N := 1 to Notes do
  Begin
    WriteLn('         ', N);
    Write(': ');
      ReadLn(NoteBook[N].Name);
    Write(' ஦ (..  //): ');
      ReadLn(TempStr);
      If ((TempStr[3]='.') AND (TempStr[6]='.')) OR ((TempStr[3]='/') AND (TempStr[6]='/')) Then
      Begin
        Val(Copy(TempStr, 1, 2), NoteBook[N].BirthDate.Day, Error);
        Val(Copy(TempStr, 4, 2), NoteBook[N].BirthDate.Month, Error);
        Val(Copy(TempStr, 7, 4), NoteBook[N].BirthDate.Year, Error);
        If (NoteBook[N].BirthDate.Day = 0) OR
           (NoteBook[N].BirthDate.Month = 0) OR
           (NoteBook[N].BirthDate.Day > 31) OR
           (NoteBook[N].BirthDate.Month > 12) OR
           ((NoteBook[N].BirthDate.Month mod 2 = 0) AND
             (NoteBook[N].BirthDate.Day = 31)) OR
           ((NoteBook[N].BirthDate.Year mod 4 <> 0) AND
             (NoteBook[N].BirthDate.Month = 2) AND
               (NoteBook[N].BirthDate.Day >= 29)) Then
          Error := 666;
      If (NoteBook[N].BirthDate.Day = 31) AND
         (NoteBook[N].BirthDate.Month = 8) Then
        Error:=0;
        If Error <> 0 Then
        Begin
          WriteLn('訡  ८ࠧ !');
          Exit
        End
      End
      Else
      Begin
        WriteLn('訡  ଠ !');
        Exit
      End;
    Write('  ⥫䮭: ');
      ReadLn(NoteBook[N].Phone);
    Write('  (, த, 㫨,  ,  ,  ):');
      ReadLn(TempStr);
      NoteBook[N].Adr.ZIP := Copy(TempStr, 1, 6);
        Delete(TempStr, 1, 8);
      TempByte := Pos(', ', TempStr);
        NoteBook[N].Adr.City := Copy(TempStr, 1, TempByte-1);
        Delete(TempStr, 1, TEmpByte+1);
      TempByte := Pos(', ', TempStr);
        NoteBook[N].Adr.Street := Copy(TempStr, 1, TempByte-1);
        Delete(TempStr, 1, TempByte+1);
      TempByte := Pos(', ', TempStr);
        Val(Copy(TempStr, 1, TEmpByte-1), NoteBook[N].Adr.House, Error);
        Delete(TempStr, 1, TempByte+1);
      TempByte := Pos(', ', TempStr);
        Val(Copy(TempStr, 1, TempByte-1), NoteBook[N].Adr.Korpus, Error);
        Delete(TempStr, 1, TempByte+1);
      Val(Copy(TempStr, 1, Length(TempStr)), NoteBook[N].Adr.Kvartira, Error);
      If Error <> 0 Then
      Begin
        WriteLn('訡  ८ࠧ !');
        Exit
      End
  End;
  WriteLn(' ⥪ : ');
    ReadLn(TempStr);
    If ((TempStr[3]='.') AND (TempStr[6]='.')) OR ((TempStr[3]='/') AND (TempStr[6]='/')) Then
    Begin
      Val(Copy(TempStr, 1, 2), CurrentDate.Day, Error);
      Val(Copy(TempStr, 4, 2), CurrentDate.Month, Error);
      Val(Copy(TempStr, 7, 4), CurrentDate.Year, Error);
      If (CurrentDate.Day = 0) OR
         (CurrentDate.Month = 0) OR
         (CurrentDate.Day > 31) OR
         (CurrentDate.Month > 12) OR
         ((CurrentDate.Month mod 2 = 0) AND
           (CurrentDate.Day = 31)) OR
         ((CurrentDate.Year mod 4 <> 0) AND
           (CurrentDate.Month = 2) AND
             (CurrentDate.Day >= 29)) Then
        Error := 666;
      If (CurrentDate.Day = 31) AND
         (CurrentDate.Month = 8) Then
        Error:=0;
      If Error <> 0 Then
      Begin
        WriteLn('訡  ८ࠧ !');
        Exit
      End
    End
    Else
    Begin
      WriteLn('訡  ଠ !');
      Exit
    End;
  For N := 1 to Notes do
  Begin
    If NoteBook[N].Phone <> '' Then
    Begin
      If (CurrentDate.Day = NoteBook[N].BirthDate.Day) AND
         (CurrentDate.Month = NoteBook[N].BirthDate.Month) Then
        WriteLn(' / ', NoteBook[N].Name,
          '!    ⥫䮭 ', NoteBook[N].Phone,
          '  ࠢ !')
    End
    Else
    Begin
      If (CurrentDate.Month mod 2 = 1) OR (CurrentDate.Month = 8) Then
        TempByte := 28+NoteBook[N].BirthDate.Day
      Else
        If CurrentDate.Month <> 2 Then
          TempByte := 27+NoteBook[N].BirthDate.Day
        Else
          If CurrentDate.Year mod 4 = 0 Then
            TempByte := 26+NoteBook[N].BirthDate.Day
          Else
            TempByte := 25+NoteBook[N].BirthDate.Day;
      If ((CurrentDate.Day = NoteBook[N].BirthDate.Day-3) AND
           (CurrentDate.Month = NoteBook[N].BirthDate.Month)) OR
         ((NoteBook[N].BirthDate.Day < 4) AND
           (NoteBook[N].BirthDate.Month = CurrentDate.Month+1) AND
             (CurrentDate.Day = TempByte)) Then
        WriteLn('१   /  ',
          NoteBook[N].Name,
          '! ࠢ     "',
          NoteBook[N].Adr.ZIP, ', ',
          NoteBook[N].Adr.City, ', ',
          NoteBook[N].Adr.Street, ', ',
          NoteBook[N].Adr.House, ', ',
          NoteBook[N].Adr.Korpus, ', ',
          NoteBook[N].Adr.Kvartira, '"!')
    End
  End
End.