Uses
  CRT, DOS, Graph;
{============================================================================}
Function Menu: Byte;
Var
  MenuItem: Byte;
  Key: Char;
Begin
  TextMode(Co80);
  TextBackground(Black);
  TextColor(Black);
  ClrScr;
  Window(35,16,46,20);
  MenuItem := 0;
  Repeat
    TextBackGround(Yellow);
    ClrScr;
    WriteLn;
    Case MenuItem of
      0: Begin
        Write(' 1) 䨪 ');
        Write(' 2)  ');
        Write(' 3) 室   ')
      End;
      1:
      Begin
        TextBackground(Red);
        Write(' 1) 䨪 ');
        TextBackground(Yellow);
        Write(' 2)  ');
        Write(' 3) 室   ')
      End;
      2:
      Begin
        Write(' 1) 䨪 ');
        TextBackground(Red);
        Write(' 2)  ');
        TextBackGround(Yellow);
        Write(' 3) 室   ')
      End;
      3:
      Begin
        Write(' 1) 䨪 ');
        Write(' 2)  ');
        TextBackground(Red);
        Write(' 3) 室   ')
      End
      Else
        Halt(1)
    End;
    Case ReadKey of
      #49: MenuItem := 1;
      #50: MenuItem := 2;
      #51: MenuItem := 3;
      #13:
      Begin
        Result := MenuItem;
        Exit;
      End;
      #0: Case ReadKey of
        #80:
          If MenuItem >= 3 Then
            MenuItem := 1
          Else
            MenuItem := MenuItem + 1;
        #72:
          If MenuItem <= 1 Then
            MenuItem := 3
          Else
            MenuItem := MenuItem - 1
      End
    End
  Until False
End;
{----------------------------------------------------------------------------}
Procedure Video;
Type
  Point = Record
    X: LongInt;
    Y: LongInt;
  End;
  ArrayEx = Array [1..8] of Point;
Var
  Driver, Mode: SmallInt;
  StartAnimTime, EndAnimTime: Extended;
  StartArr, EndArr, CurArr: ArrayEx;
  Ch: char;
  Z: 0..3;
  {--------------------------------------------------------------------------}
  Function GetTimeEx: Extended;
  // 頥 ⢮ ᥪ㭤, 襤  砫 ⮪ (. .  00:00:00)
  Var
    Time: Extended;
    Hour, Minute, Second, Sec100: Word;
  Begin
    GetTime(Hour, Minute, Second, Sec100);
    Time := (Hour * 3600.0) + (Minute * 60.0) + Second + (Sec100 / 100.0);
    Result := Time
  End;
  {--------------------------------------------------------------------------}
  Procedure LockFPS(FPS: Extended);
  // ࠭稢 ᪮ ᮢ ਬ୮ FPS ࠬ  ᥪ㭤
  Var
    StartTime: Extended;
  Begin
    StartTime := GetTimeEx;
    Repeat
    Until GetTimeEx > (StartTime + (1.0 / FPS))
  End;
  {--------------------------------------------------------------------------}
  Procedure InitStartArr;
  //  ᨢ 砫 祭
  Begin
    StartArr[1].X := GetMaxX div 2;
    StartArr[1].Y := GetMaxY div 3;
    StartArr[2].X := (GetMaxX div 3) * 2;
    StartArr[2].Y := StartArr[1].Y;
    StartArr[3].X := StartArr[2].X;
    StartArr[3].Y := GetMaxY div 2;
    StartArr[4].X := StartArr[3].X;
    StartArr[4].Y := (GetMaxY div 3) * 2;
    StartArr[5].X := StartArr[1].X;
    StartArr[5].Y := StartArr[4].Y;
    StartArr[6].X := GetMaxX div 3;
    StartArr[6].Y := StartArr[5].Y;
    StartArr[7].X := StartArr[6].X;
    StartArr[7].Y := StartArr[3].Y;
    StartArr[8].X := StartArr[7].X;
    StartArr[8].Y := StartArr[1].Y;
  End;
  {--------------------------------------------------------------------------}
  Procedure InitEndArr;
  //  ᨢ  祭
  Begin
    EndArr[1].X := StartArr[1].X;
    EndArr[1].Y := StartArr[1].Y;
    EndArr[2].X := (StartArr[1].X + StartArr[2].X) div 2;
    EndArr[2].Y := (StartArr[1].Y + StartArr[3].Y) div 2;
    EndArr[3].X := StartArr[3].X;
    EndArr[3].Y := StartArr[3].Y;
    EndArr[4].X := (StartArr[4].X + StartArr[5].X) div 2;
    EndArr[4].Y := (StartArr[3].Y + StartArr[5].Y) div 2;
    EndArr[5].X := StartArr[5].X;
    EndArr[5].Y := StartArr[5].Y;
    EndArr[6].X := (StartArr[5].X + StartArr[6].X) div 2;
    EndArr[6].Y := (StartArr[5].Y + StartArr[7].Y) div 2;
    EndArr[7].X := StartArr[7].X;
    EndArr[7].Y := StartArr[7].Y;
    EndArr[8].X := (StartArr[7].X + StartArr[1].X) div 2;
    EndArr[8].Y := (StartArr[7].Y + StartArr[1].Y) div 2;
  End;
  {--------------------------------------------------------------------------}
  Procedure CalcCurArr;
  // 뢠 ⥪騩  樨
  Var
    B: 1..8;
    E: Extended;
  Begin
    E := (StartAnimTime - EndAnimTime) / (StartAnimTime - GetTimeEx);
    For B := 1 to 8 do
    Begin
      CurArr[B].X := StartArr[B].X-Trunc((StartArr[B].X-EndArr[B].X)/E);
      CurArr[B].Y := StartArr[B].Y-Trunc((StartArr[B].Y-EndArr[B].Y)/E)
    End
  End;
  {--------------------------------------------------------------------------}
  Procedure DrawCurArr;
  // ⮡ࠦ CurArr
  Var
    B: 1..8;
  Begin
    For B := 1 To 7 Do
    Begin
      SetColor(B);
      Line(CurArr[B].X, CurArr[B].Y, CurArr[B+1].X, CurArr[B+1].Y)
    End;
    SetColor(B+1);
    Line(CurArr[8].X, CurArr[8].Y, CurArr[1].X, CurArr[1].Y)
  End;
  {--------------------------------------------------------------------------}
Begin
  Driver := Detect;
  InitGraph(Driver, Mode, '');
  StartAnimTime := GetTimeEx;
  InitStartArr;
  InitEndArr;
  CurArr := StartArr;
  EndAnimTime := StartAnimTime + 5.0;  // த⥫쭮 樨 - 5 ᥪ.
  Repeat
    ClearDevice;
    CalcCurArr;
    DrawCurArr;
    If KeyPressed Then
      If ReadKey = ' ' Then
      Begin
        CloseGraph;
        Exit
      End;
    OutText('Morphing Amimation. Press [SPACE] to break');
    LockFPS(33)
  Until GetTimeEx > EndAnimTime;
  CloseGraph
End;
{----------------------------------------------------------------------------}
Procedure PlaySound;
Begin
  // 㪠      TP7 :-(
End;
{============================================================================}
Var
  Select: Byte;
Begin
  Repeat
    Select := Menu;
    Case Select of
      1: Video;
      2: PlaySound
    End
  Until Select = 3
End.