{
 ********************************************************************
 *   1:                                                       *
 *   ஢ 㭪  ६ ⮤  ୮   *
 ********************************************************************
}
Type
  Map = Array [1..4, 1..4] of Byte;
  Table = array [0..15] of Boolean;
Var
  KarnoMap: Map;                        {  ୮  4- ६ }
  TI: Table;                            {  ⨭ }
  InputStrng: String;                   {  ,   f=1 }
  MDNF: array [0..1] of String;         { 1- ᠬ , 0 - 栭 }
  Error: Word;                          { 訡 }
{============================================================================}
Procedure InitTI(S: String);
{ ⠢  ⨭ }
Var
  B: Byte;     { 饭 ࢮ ஡  ப }
  V: Byte;     { ஢   }
Begin
  While S <> '' do
  Begin
    B := Pos(' ', S);
    If B > 0 Then
    Begin
      Case S[B-1] of
        '0'..'9': Val(Copy(S, 1, B-1), V, Error);
        ',': Val(Copy(S, 1, B-2), V, Error)
      End;
      Delete(S, 1, B)
    End
    Else
    Begin
      Val(Copy(S, 1, Length(S)), V, Error);
      S:= ''
    End;
    If Error > 0 Then
    Begin
      WriteLn('訡  Val, S="', S, '", Error=', Error);
      Exit
    End;
    Case V of
      0..15:
        If Error = 0 Then
          TI[V]:= True;
      Else
      Begin
        WriteLn('訡,  0<V<15,  V=', V);
        Error := $FFFF;
        Exit
      End
    End
  End
End;
{----------------------------------------------------------------------------}
Procedure InitMap(T: Table; Var M: Map);
{ ⠢  ୮   ⨭ }
Var
  B: 0..15; {   }
Begin
  For B := 0 to 15 do
    If T[B] Then
      Case B of
        0 : M[4,4] := 1;
        1 : M[1,4] := 1;
        2 : M[4,1] := 1;
        3 : M[1,1] := 1;
        4 : M[3,4] := 1;
        5 : M[2,4] := 1;
        6 : M[3,1] := 1;
        7 : M[2,1] := 1;
        8 : M[4,3] := 1;
        9 : M[1,3] := 1;
        10: M[4,2] := 1;
        11: M[1,2] := 1;
        12: M[3,3] := 1;
        13: M[2,3] := 1;
        14: M[3,2] := 1;
        15: M[2,2] := 1
      End
End;
{----------------------------------------------------------------------------}
Procedure ShowMap(M: Map);
Begin
  WriteLn('          __     ');
  WriteLn('      X2  X2     ');
  WriteLn('                 ');
  WriteLn('     Ŀ __ ');
  WriteLn('     ', M[1,1], '', M[1,2], '', M[1,3], '', M[1,4], ' X3 ');
  WriteLn('  X1 ');
  WriteLn('     ', M[2,1], '', M[2,2], '', M[2,3], '', M[2,4], '    ');
  WriteLn(' Ĵ X3 ');
  WriteLn('  __ ', M[3,1], '', M[3,2], '', M[3,3], '', M[3,4], '    ');
  WriteLn('  X1 ');
  WriteLn('     ', M[4,1], '', M[4,2], '', M[4,3], '', M[4,4], ' __ ');
  WriteLn('      X3 ');
  WriteLn('    __     __   ');
  WriteLn('    X4  X4 X4   ');
  WriteLn('                ');
End;
{----------------------------------------------------------------------------}
Procedure CreateMDNF(M: Map);
{ ⠢    ୮ }
Type
  K = Array [0..7] of Boolean;
  { ⥫쭠 ,  񭭮 樨
    0 - 
    1 -   ப
    2 -   ⮫
    3 - ப  
    4 - ⮫  
    5 -   
    6 -  ப  
    7 -  ⮫  
  }
Var
  X, X1, Y, Y1: 1..4;              {  Map }
  B: Byte;                         {  K }
  MinMap: Array [1..4, 1..4] of K; { ⥫쭠  }
Begin
  For X := 1 to 4 do
    For Y := 1 to 4 do
      For B := 0 to 7 do
        MinMap[X,Y,B] := False;
  { ⠭   ⥫쭮  }
  For X := 1 to 4 do
    For Y := 1 to 4 do
      If M[X,Y] = 1 Then
        MinMap[X,Y,0] := True;
  { 宦  }
  For X := 1 to 4 do
    For Y := 1 to 4 do
    Begin
      If MinMap[X,1,0] AND MinMap[X,4,0] Then
        MinMap[X,4,1] := True;
      If Y < 4 Then
        If MinMap[X,Y,0] AND MinMap[X,Y+1,0] Then
          MinMap[X,Y,1] := True;
      If MinMap[1,Y,0] AND MinMap[4,Y,0] Then
        MinMap[4,Y,2] := True;
      If X < 4 Then
        If MinMap[X,Y,0] AND MinMap[X+1,Y,0] Then
          MinMap[X,Y,2] := True
    End;
  { 뤥   ப }
  For X := 1 to 4 do
    If MinMap[X,1,1] AND MinMap[X,3,1] Then
      MinMap[X,1,3] := True;
  For Y := 1 to 4 do
    If MinMap[1,Y,2] AND MinMap[3,Y,2] Then
      MinMap[1,Y,4] := True;
  { 뤥   ⮢ }
  For X := 1 to 4 do
    For Y := 1 to 4 do
    Begin
      If (X < 4) AND (Y < 4) Then
        If MinMap[X,Y,1] AND MinMap[X+1,Y,1] AND
           MinMap[X,Y,2] AND MinMap[X,Y+1,2] Then
          MinMap[X,Y,5] := True;
      If (X = 4) AND (Y < 4) Then
        If MinMap[4,Y,1] AND MinMap[4,Y,2] AND
           MinMap[4,Y+1,2] AND MinMap[1,Y,1] Then
          MinMap[X,Y,5] := True;
      If (X < 4) AND (Y = 4) Then
        If MinMap[X,4,1] AND MinMap[X,4,2] AND
        MinMap[X+1,4,1] AND MinMap[X,1,2] Then
          MinMap[X,Y,5] := True;
      If (X = 4) AND (Y = 4) Then
        If MinMap[4,4,1] AND MinMap[1,4,1] AND
           MinMap[4,4,2] AND MinMap[4,1,2] Then
          MinMap[4,4,5] := True;
    End;
  { 뤥  ⮢ ப}
  For X := 1 to 4 do
    If MinMap[X,1,5] AND MinMap[X,3,5] Then
      MinMap[X,1,6] := True;
  For Y := 1 to 4 do
    If MinMap[1,Y,5] AND MinMap[3,Y,5] Then
      MinMap[1,Y,7] := True;
  {  譨  }
  For X := 1 to 4 do
    For Y := 1 to 4 do
    Begin
      If MinMap[X,Y,1] Then
      Begin
        If Y < 4 Then
        Begin
          MinMap[X,Y,0] := False;
          MinMap[X,Y+1,0] := False
        End
        Else
        Begin
          MinMap[X,1,0] := False;
          MinMap[X,4,0] := False
        End
      End;
      If MinMap[X,Y,2] Then
        If X < 4 Then
        Begin
          MinMap[X,Y,0] := False;
          MinMap[X+1,Y,0] := False
        End
        Else
        Begin
          MinMap[1,Y,0] := False;
          MinMap[4,Y,0] := False
        End
    End;
  {  譨  }
  For X := 1 to 4 do
    For Y := 1 to 4 do
    Begin
      If MinMap[X,Y,3] Then
        For Y1 := 1 to 4 do
          MinMap[X,Y1,1] := False;
      If MinMap[X,Y,4] Then
        For X1 := 1 to 4 do
          MinMap[X1,Y,2] := False;
      If MinMap[X,Y,5] Then
      Begin
        If (X < 4) AND (Y < 4) Then
        Begin
          MinMap[X,Y,1] := False;
          MinMap[X,Y,2] := False;
          MinMap[X+1,Y,1] := False;
          MinMap[X,Y+1,2] := False
        End;
        If (X = 4) AND (Y < 4) Then
        Begin
          MinMap[4,Y,1] := False;
          MinMap[4,Y,2] := False;
          MinMap[4,Y+1,2] := False;
          MinMap[1,Y,1] := False
        End;
        If (X < 4) AND (Y = 4) Then
        Begin
          MinMap[X,4,1] := False;
          MinMap[X,4,2] := False;
          MinMap[X+1,4,1] := False;
          MinMap[X,1,2] := False
        End;
        If (X = 4) AND (Y = 4) Then
        Begin
          MinMap[4,4,1] := False;
          MinMap[1,4,1] := False;
          MinMap[4,4,2] := False;
          MinMap[4,1,2] := False
        End
      End
    End;
  {  譨 ப }
  For X := 1 to 4 do
    For Y := 1 to 4 do
    Begin
      If MinMap[X,Y,6] Then
      Begin
        If X < 4 Then
        Begin
          MinMap[X,1,3] := False;
          MinMap[X+1,1,3] := False;
        End;
        If X = 4 Then
        Begin
          MinMap[1,1,3] := False;
          MinMap[4,1,3] := False;
        End;
        For Y1 := 1 to 4 do
          MinMap[X,Y1,5] := False
      End;
      If MinMap[X,Y,7] Then
      Begin
        If Y < 4 Then
        Begin
          MinMap[X,Y,4] := False;
          MinMap[X,Y+1,4] := False;
        End;
        If Y = 4 Then
          MinMap[1,1,4] := False;
          MinMap[1,4,4] := False;
        For X1 := 1 to 4 do
          MinMap[X1,Y,5] := False;
      End;
    End;
  For X := 1 to 4 do
    For Y := 1 to 4 do
      For B := 0 to 7 do
        If MinMap[X,Y,B] then
          Case B of
            7: {  ⮫  }
            Case Y of
              1:
              Begin
                MDNF[0] := MDNF[0] + '   ';
                MDNF[1] := MDNF[1] + 'Vx2'
              End;
              2:
              Begin
                MDNF[0] := MDNF[0] + '   ';
                MDNF[1] := MDNF[1] + 'Vx4'
              End;
              3:
              Begin
                MDNF[0] := MDNF[0] + ' __';
                MDNF[1] := MDNF[1] + 'Vx2'
              End;
              4:
              Begin
                MDNF[0] := MDNF[0] + ' __';
                MDNF[1] := MDNF[1] + 'Vx4'
              End;
            End;
            6: {  窨  }
            Case X of
              1:
              Begin
                MDNF[0] := MDNF[0] + '   ';
                MDNF[1] := MDNF[1] + 'Vx1'
              End;
              2:
              Begin
                MDNF[0] := MDNF[0] + '   ';
                MDNF[1] := MDNF[1] + 'Vx3'
              End;
              3:
              Begin
                MDNF[0] := MDNF[0] + ' __';
                MDNF[1] := MDNF[1] + 'Vx1'
              End;
              4:
              Begin
                MDNF[0] := MDNF[0] + ' __';
                MDNF[1] := MDNF[1] + 'Vx3'
              End;
            End;
            4: { ⮫  }
            Case Y of
              1:
              Begin
                MDNF[0] := MDNF[0] + '  __    ';
                MDNF[1] := MDNF[1] + 'V(x4*x2)'
              End;
              2:
              Begin
                MDNF[0] := MDNF[0] + '        ';
                MDNF[1] := MDNF[1] + 'V(x4*x2)'
              End;
              3:
              Begin
                MDNF[0] := MDNF[0] + '     __ ';
                MDNF[1] := MDNF[1] + 'V(x4*x2)'
              End;
              4:
              Begin
                MDNF[0] := MDNF[0] + '  __ __ ';
                MDNF[1] := MDNF[1] + 'V(x4*x2)'
              End
            End;
            3: { ப  }
            Case X of
              1:
              Begin
                MDNF[0] := MDNF[0] + '  __    ';
                MDNF[1] := MDNF[1] + 'V(x3*x1)'
              End;
              2:
              Begin
                MDNF[0] := MDNF[0] + '        ';
                MDNF[1] := MDNF[1] + 'V(x3*x1)'
              End;
              3:
              Begin
                MDNF[0] := MDNF[0] + '     __ ';
                MDNF[1] := MDNF[1] + 'V(x3*x1)'
              End;
              4:
              Begin
                MDNF[0] := MDNF[0] + '  __ __ ';
                MDNF[1] := MDNF[1] + 'V(x3*x1)'
              End;
            End;
            5, 2, 1, 0: { ઠ/  ⮫/ப   }
              Case X of
                1:
                  Case Y of
                    1:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '        ';
                          MDNF[1] := MDNF[1] + 'V(x2*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    2:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '        ';
                          MDNF[1] := MDNF[1] + 'V(x4*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '     __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '     __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    3:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    ';
                          MDNF[1] := MDNF[1] + 'V(x2*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    4:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                  End;
                2:
                  Case Y of
                    1:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '        ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '           ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __          ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    2:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '        ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '           ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '           ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '              ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    3:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '        __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '     __    ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '        __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    4:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End
                  End;
                3:
                  Case Y of
                    1:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ ';
                          MDNF[1] := MDNF[1] + 'V(x2*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '        __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __       __';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    2:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '        __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '        __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '           __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    3:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x2*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '        __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    4:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x1)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x2*x1)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End
                  End;
                4:
                  Case Y of
                    1:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    2:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '     __    ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '     __    __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    3:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x3*x2*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '     __ __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End;
                    4:
                      Case B of
                        5:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3)'
                        End;
                        2:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2)'
                        End;
                        1:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x1)'
                        End;
                        0:
                        Begin
                          MDNF[0] := MDNF[0] + '  __ __ __ __ ';
                          MDNF[1] := MDNF[1] + 'V(x4*x3*x2*x1)'
                        End
                      End
                  End
              End
          End
End;
{============================================================================}
Begin
  Repeat
    WriteLn('   ६,   f=1:');
    ReadLn(InputStrng);
    If InputStrng = '' Then
    Begin
      WriteLn('訡!   ப');
      Error := $FF;
    End;
{ ⠢  }
    InitTI(InputStrng);
  Until Error = 0;
{ ⠢  ୮ }
  InitMap(TI, KarnoMap);
  ShowMap(KarnoMap);
{ 祭  () }
  CreateMDNF(KarnoMap);
  MDNF[1,1] := ' ';
  WriteLn(MDNF[0]);
  WriteLn(MDNF[1]);
End.