Type
  L = ^R;
  R = record
    Slovo: String;
    Next: L;
  End;
Var
  F: Text;
  List: L;
Procedure CreateFile;
Var
  S: String;
Begin
  {$I-}
  Reset(F);
  {$I+}
  If IOResult = 0 Then
    Exit;
  Rewrite(F);
  Repeat
    ReadLn(S);
    WriteLn(F, S)
  Until S = '';
  Close(F)
End;
Function GetFirstWord(Var S: String): String;
Var
  B: Byte;
Begin
  B := Pos(' ', S);
  If B > 0 Then
  Begin
    GetFirstWord := Copy(S, 1, B-1);
    Delete(S, 1, B)
  End
  Else
  Begin
    GetFirstWord := S;
    S := ''
  End
End;
Procedure CreateList;
Var
  Str, Slovo: String;
  P: L;
Begin
  Reset(F);
  While Not EoF(F) do
  Begin
    ReadLn(F, Str);
    Repeat
      Slovo := GetFirstWord(Str);
      If Slovo[1] = Slovo[Length(Slovo)] Then
      Begin
        New(P);
        P^.Slovo := Slovo;
        P^.Next := List;
        List := P
      End
    Until Slovo = ''
  End;
  Close(F)
End;
Procedure LolBeg;
Var
  P1, P2: L;
Begin
  P1 := List;
  P2 := P1^.Next;
  List := P2;
  P1^.Next := P2^.Next;
  P2^.Next := P1
End;
Procedure LolEnd;
Var
  P1, P2, P3: L;
Begin
  P1 := List;
  P2 := P1^.Next;
  P3 := P2^.Next;
  While P3^.Next <> Nil Do
  Begin
    P1 := P2;
    P2 := P3;
    P3 := P3^.Next
  End;
  P1^.Next := P3;
  P3^.Next := P2;
  P2^.Next := Nil
End;
Procedure Lol(Var P1, P2, P3: L);
Begin
  P1^.Next := P3;
  P2^.Next := P3^.Next;
  P3^.Next := P2;
  P2 := P3;
  P3 := P3^.Next;
End;
Procedure SortList;
Var
  P1, P2, P3: L;
  Z : Boolean;
Begin
  Repeat
    Z := False;
    P1 := List;
    P2 := P1^.Next;
    If P1^.Slovo > P2^.Slovo Then
    Begin
      LolBeg;
      Z := True
    End;
    P1 := List;
    P2 := P1^.Next;
    P3 := P2^.Next;
    While P3^.Next <> Nil do
    Begin
      If P2^.Slovo > P3^.Slovo Then
      Begin
        Lol(P1, P2, P3);
        Z := True
      End;
      P1 := P2;
      P2 := P3;
      P3 := P3^.Next
    End;
    If P2^.Slovo > P3^.Slovo Then
    Begin
      LolEnd;
      Z := True
    End
  Until Z = False
End;
Procedure ShowList;
Var
  P: L;
Begin
  P := List;
  While P <> Nil do
  Begin
    Write(P^.Slovo, ' >> ');
    P := P^.Next
  End;
  WriteLn('Nil');
  ReadLn
End;
Begin
  Assign(F, 'text.txt');
  CreateFile;
  List := Nil;
  CreateList;
  ShowList;
  SortList;
  ShowList
End.