{
 ॡ ᮧ  ⥪⮢ । 室 ⥪⮢ 䠩 "Input.txt",
 㤠 ᫥  ࠢ筨  䨪, ᮤঠ騩 㪠 
  ଠ.  室 ࠧࠡ ஢ ணࠬ,
      ⮣ 䠩  ⨢ 
 , ⢨ ८ࠧ ⮩ ଠ樨  뢥  
 ॡ㥬 ଥ  ⥪⮢ 䠩 - "Output.txt".  ஬
 䠩  㣨  !

 祭 类 (䠬, , ⢮)  㪠  ࠭
 몮.
 Input.txt:
   ୮  ᨫ쥢 (English, German); ਫ  ᫨
   (Portuguese, Spanish);  ⨭  (English, French,
   Finnish);   ᨯ (English)
 Output.txt:
   English:  ୮, ⨭ ,  
   German:  ୮  ..
}
Type
  Note = Record            {   瘟:  }
      SurName: String;     {            }
      Name: String;        {                }
      Patronymic: String;  {   ⢮        }
      Langueges: String    {    모 }
    End;
  Notes = Array [1..10] of Note; { ᮪ 类 }
Var
  InFile, OutFile: Text; { 室  室 䠩           }
  TempStr: String;       { ப  ࠭ "᪠ " }
  SeaMans: Notes;        { ଠ  猪               }
  Z: Word;               { ⢮ 类                 }
{============================================================================}
Procedure InitFiles;
{ 뢠 ६  䠩  뢠/ᮧ 䠩 }
Begin
  Assign(InFile, 'E:\lg_balukation\Programs\Practice4\Input.txt');
  ReSet(InFile);
  Assign(OutFile, 'E:\lg_balukation\Programs\Practice4\Output.txt');
  ReWrite(OutFile)
End;
{----------------------------------------------------------------------------}
Procedure CloseFiles;
{ 뢠 䠩 }
Begin
  Close(InFile);
  Close(OutFile)
End;
{----------------------------------------------------------------------------}
Function GetFirstWord(Var S: String): String;
{ 뤥 ࢮ ᫮ }
Var
  B: Byte; {  ࢮ ஡ }
Begin
  B := Pos(' ', S);
  If B > 0 Then
  Begin
    GetFirstWord := Copy(S, 1, B-1);
    Delete(S, 1, B)
  End
  Else
  Begin
    GetFirstWord := S;
    S := ''
  End
End;
{----------------------------------------------------------------------------}
Function GetRec: String;
{ 뤥  ப   瘟  -樨 GetNode }
Var
  B: Byte;      {    -  ";" }
  N, Kol: Byte; { 稪 ᨬ  ஡     }
  S : String;   { ப  䠩                  }
Begin
  ReadLn(InFile, S);
  Kol := 0;
  If TempStr <> '' Then
    S := Concat(TempStr, ' ', S);
  B := Pos(';', S);
  If B = 0 Then
  Begin
    S := Concat(S, ';');
    B := Length(S)
  End;
  For N := 1 to B do
    If S[N] = ' ' Then
      Kol := Kol + 1;
  If Kol > 2 Then
    GetRec := Copy(S, 1, B)
  Else
    GetRec := Concat(TempStr, ' ', Copy(S, 1, B));
  TempStr := '';
  If B < Length(S) Then
    TempStr := Copy(S, B + 2, Length(S) - B - 1)
End;
{----------------------------------------------------------------------------}
Function GetNote: Note;
{  ப ନ  }
Var
  S: String;
Begin
  S := GetRec;
  GetNote.SurName := GetFirstWord(S);
  GetNote.Name := GetFirstWord(S);
  GetNote.Patronymic := GetFirstWord(S);
  GetNote.Langueges := Copy(S, 2, Length(S)-3)
End;
{----------------------------------------------------------------------------}
Procedure InitNotes(var A: Notes; var N: Word);
{ ନ ᯨ᮪ 类 }
Begin
  N := 1;
  Repeat
    A[N] := GetNote;
    N := N+1
  Until EoF(InFile);
  N := N - 1
End;
{----------------------------------------------------------------------------}
Function CreateLangList(A: Notes; N: Word): String;
{ ନ ᯨ᮪ 뮢 }
Var
  I: Word;
  B1, B2: Byte;
  S1, S2, Str: String;
Begin
  For I := 1 to N do
  Begin
    S1 := A[I].Langueges;
    Repeat
      B1 := Pos(', ', S1);
      If B1 > 0 Then
      Begin
        S2 := Copy(S1, 1, B1 - 1);
        B2 := Pos(S2, Str);
        If B2 = 0 Then
          Str := Concat(Str, ' ', S2);
        Delete(S1, 1, B1 + 1)
      End
      Else
      Begin
        B2 := Pos(S1, Str);
        If B2 = 0 Then
          Str := Concat(Str, ' ', S1);
        S1 := ''
      End
    Until S1 = ''
  End;
  CreateLangList := Copy(Str, 2, Length(Str)-1)
End;
{----------------------------------------------------------------------------}
Function CreateList(A: Notes; N: Word; Var I: String): String;
{  ᯨ᮪ 类,     ᯨ᪠ }
Var
  Lang, S: String; { , ப  뢮        }
  B: Byte;              {   类 몠 Lang }
  Z: Word;          {  ᨢ                 }
Begin
  Lang := GetFirstWord(I);
  If Lang = '' Then
    I := ''
  Else
  Begin
    S := Concat(Lang, ':');
    For Z := 1 to N Do
    Begin
      B := Pos(Lang, A[Z].Langueges);
      If B <> 0 Then
        S := Concat(S, ' ', A[Z].Name, ' ', A[Z].SurName, ',')
    End
  End;
  CreateList := Copy(S, 1, Length(S) - 1)
End;
{----------------------------------------------------------------------------}
Procedure CreateReport(A: Notes; N: Word);
{     猪 ࠭ 몮 }
Var
  I: String; { ᮪ ⠢ 몮 }
  L: String; { 騩              }
Begin
{ ⠢ ᯨ᪠ 몮 }
  I := CreateLangList(A,N);
  Repeat
    WriteLn(OutFile, CreateList(A, N, I))
  Until I = ''
End;
{============================================================================}
Begin
  InitFiles;
  InitNotes(SeaMans, Z);
  CreateReport(SeaMANS, Z);
  CloseFiles
End.